Docker Support - Issue #739

Not a directory error when publishing
03/06/2015 03:23 PM - jgreguske

Status: CLOSED - WORKSFORME Start date:

Priority: High Due date:

Assignee: Estimated time: 0:00 hour
Category:

Sprint/Milestone:

Severity: 2. Medium Groomed: No
Version - Docker: master Sprint Candidate: No
Platform Release: Tags: Pulp 2
Target Release - Sprint:

Docker:

0Os: Quarter:

Triaged: Yes

Description

When publishing a docker repository, | get an error.
Here are details of the repository

{'_href': '/pulp/api/v2/repositories/redhat-openshift3_beta-ose-deployer/"',
'_id': {'$Soid': '54f8dabbaa%ea96c3522e6d7'},
'_ns': 'repos',
'content_unit_counts': {'docker_image': 9},
'description': 'Handles deploying containers when new versions are available or triggered',
'display_name': 'redhat-openshift3_beta-ose-deployer',
'distributors': [{'_id': {'$Soid': '54f8da6bbaa9ea96c3522e6da’'},
'_ns': 'repo_distributors',
'auto_publish': True,
'config': {'protected': False,
'redirect-url': 'http://internal.redhat.server.com/containers/regist
ry/"',
'repo-registry-id': 'openshift3_beta/ose-deployer'},
'distributor_type_id': 'docker_distributor_web',
'id': 'docker_web_distributor_name_cli',
'last_publish': '2015-03-06T13:44:072"',
'repo_id': 'redhat-openshift3_beta-ose-deployer',
'scheduled_publishes': []},
'_id': {'$Soid': '54f8dabbaa%ead96c3522e6d9'},
'_ns': 'repo_distributors',

—_—

'auto_publish': True,
'config': {'protected': False,
'redirect-url': 'http://internal.redhat.server.com/containers/regist
ry/"',
'repo-registry-id': 'openshift3_beta/ose-deployer'},
'distributor_type_id': 'docker_distributor_export',
'id': 'docker_export_distributor_name_cli',
'last_publish': '2015-03-06T13:44:00z2"',
'repo_id': 'redhat-openshift3_beta-ose-deployer',
'scheduled_publishes': []}],
'id': 'redhat-openshift3_beta-ose-deployer',
'importers': [{'_id': {'Soid': '54f8dabbaa%9ea96c3522e6d8"'},
'_ns': 'repo_importers',
'config': {1},
'id': 'docker_importer',
'importer_type_id': 'docker_importer',
'last_sync': None,
'repo_id': 'redhat-openshift3_beta-ose-deployer',
'scheduled_syncs': [1}1,
'"last_unit_added': '2015-03-05T22:36:28z"',
'last_unit_removed': None,

'notes': {'_repo-type': 'docker-repo'},
'scratchpad': {'tags': [{'image_id': 'c6bc2d82fcfd0c7a5a9560970b520dc7dddbc477bd97065aeb421b1749¢c
8b73b"',
'tag': 'latest'},

{'image_1id': 'c6bc2d82fcfd0c7a5a9560970b520dc7dddbc477bd97065aeb421bl1749¢
8b73b"',
"tag': 'v0.3'}]1}}

Attempting to publish with the REST API (or CLI) leads to a traceback in the spawned subtask:

Traceback (most recent call last):
File "/usr/lib/python2.6/site-packages/celery/app/trace.py", line 240, in trace_task

R = retval = fun(*args, **kwargs)
File "/usr/lib/python2.6/site-packages/pulp/server/async/tasks.py", line 337, in __call___
return super (Task, self)._ _call__ (*args, **kwargs)

File "/usr/lib/python2.6/site-packages/celery/app/trace.py", line 437, in _ protected_call___
return self.run(*args, **kwargs)
File "/usr/lib/python2.6/site-packages/pulp/server/managers/repo/publish.py", line 98, in publis
h
transfer_repo, conduit, call_config)
File "/usr/lib/python2.6/site-packages/pulp/server/managers/repo/publish.py", line 130, in _do_p
ublish
publish_report = publish_repo (transfer_repo, conduit, call_config)
File "/usr/lib/python2.6/site-packages/pulp/server/async/tasks.py", line 492, in wrap_f
return f (*args, **kwargs)
File "/opt/pulp_docker/plugins/pulp_docker/plugins/distributors/distributor_web.py", line 123, i
n publish_repo
return self._publisher.publish ()
File "/usr/lib/python2.6/site-packages/pulp/plugins/util/publish_step.py", line 508, in publish
return self.process_lifecycle()
File "/usr/lib/python2.6/site-packages/pulp/plugins/util/publish_step.py", line 457, in process_
lifecycle
super (PluginStep, self) .process_lifecycle()
File "/usr/lib/python2.6/site-packages/pulp/plugins/util/publish_step.py", line 122, in process_
lifecycle
step.process ()
File "/usr/lib/python2.6/site-packages/pulp/plugins/util/publish_step.py", line 180, in process
self._process_block ()
File "/usr/lib/python2.6/site-packages/pulp/plugins/util/publish_step.py", line 215, in _process
_block
self.process_main ()
File "/usr/lib/python2.6/site-packages/pulp/plugins/util/publish_step.py", line 776, in process_
main
shutil.copytree (timestamp_master_location, publish_location, symlinks=True)
File "/usr/lib64/python2.6/shutil.py", line 136, in copytree
names = os.listdir (src)
OSError: [Errno 20] Not a directory: '/var/lib/pulp/published/docker/master/redhat-openshift3_beta
—ose-deployer/1425648629.96/redhat-openshift3_beta-ose-deployer. json'

History

#1 - 03/10/2015 02:59 PM - mhrivnak
- Sprint/Milestone deleted (13)

#2 - 03/10/2015 03:28 PM - mhrivnak

It looks like when you filed this issue, you scheduled it onto our March sprint. Please don't do that. :)

#3 - 03/10/2015 04:26 PM - dkliban@redhat.com
- Priority changed from Normal to High

- Severity changed from High to Medium

- Triaged changed from No to Yes
#4 - 03/10/2015 10:53 PM - mhrivnak

Is this a brand new pulp, or an upgrade?
How did you get this docker repo in? Upload? Sync?
#5 - 03/11/2015 01:25 PM - jgreguske
mhrivnak wrote:
Is this a brand new pulp, or an upgrade?
How did you get this docker repo in? Upload? Sync?

New instance of Pulp 2.5.3 Repositories were created manually, and then images were uploaded to them. All interactions were done over the REST
API. I'll send you the images | used elsewhere.

#6 - 03/16/2015 09:32 PM - mhrivnak
For those playing along at home, Jay is working through multiple issues where the deployed pulp code was not the expected version. At this point, it

seems unlikely that this is a pulp bug. But, Jay will report back once he can try with an legit deployment.

#7 - 03/20/2015 08:15 PM - bmbouter

- Severity changed from Medium to 2. Medium

#8 - 05/05/2015 05:01 PM - bmbouter
- Version deleted (2.5)

- Version - Docker set to master

#9 - 10/02/2015 03:38 PM - ipanova@redhat.com
- Status changed from NEW to CLOSED - WORKSFORME

Was not able to reproduce, in case this issue appears again, please re-open.

#10 - 04/15/2019 11:04 PM - bmbouter
- Tags Pulp 2 added
